%{
/*	$Id: bibfix.l,v 2.7 2004/03/20 17:18:35 bronger Exp $
=======================================================================
     bibfix.l - Part of the tbook Program
     Copyright 2002--2004 Torsten Bronger
                          <bronger@users.sourceforge.net>

   This program is free software; you can redistribute it and/or
   modify it under the terms of the Artistic License 2.0 as published
   by Larry Wall.  You should have received a copy of the Artistic
   License 2.0 along with this program in the file COPYING; if not,
   you can get it at
     http://dev.perl.org/rfc/346.html
   or contact the current maintainer of tbook.

   This program is distributed in the hope that it will be useful, but
   WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   Artistic License 2.0 for more details.

   This file may only be distributed together with a copy of the tbook
   program.

   The tbook program consists of all files listed in manifest.txt.
=======================================================================*/

/* Fileversion: 1.5 
   Filedate:    2003/04/02 */

void put_possibly(char c) {
  if (c != '{' && c != '}' && c != '\\')
    putchar(c);
}

%}

%s inmath inurl inmisc inemph textsuper

%%

\\\`(\{)?A           { printf("&#xc0;"); }
\\\'(\{)?A           { printf("&#xc1;"); }
\\\^(\{)?A           { printf("&#xc2;"); }
\\\~(\{)?A           { printf("&#xc3;"); }
\\\"(\{)?A           { printf("&#xc4;"); }
\\\r(\{)?A           { printf("&#xc5;"); }
\\AE                 { printf("&#xc6;"); }
\\\c(\{)?C           { printf("&#xc7;"); }
\\\`(\{)?E           { printf("&#xc8;"); }
\\\'(\{)?E           { printf("&#xc9;"); }
\\\^(\{)?E           { printf("&#xca;"); }
\\\"(\{)?E           { printf("&#xcb;"); }
\\\`(\{)?I           { printf("&#xcc;"); }
\\\'(\{)?I           { printf("&#xcd;"); }
\\\^(\{)?I           { printf("&#xce;"); }
\\\"(\{)?I           { printf("&#xcf;"); }

\\\~(\{)?N           { printf("&#xd1;"); }
\\\`(\{)?O           { printf("&#xd2;"); }
\\\'(\{)?O           { printf("&#xd3;"); }
\\\^(\{)?O           { printf("&#xd4;"); }
\\\~(\{)?O           { printf("&#xd5;"); }
\\\"(\{)?O           { printf("&#xd6;"); }
\\OE                 { printf("OE"); }
\\O                  { printf("&#xd8;"); }
\\\`(\{)?U           { printf("&#xd9;"); }
\\\'(\{)?U           { printf("&#xda;"); }
\\\^(\{)?U           { printf("&#xdb;"); }
\\\"(\{)?U           { printf("&#xdc;"); }
\\\'(\{)?Y           { printf("&#xdd;"); }

\\ss                 { printf("&#xdf;"); }
\\\`(\{)?a           { printf("&#xe0;"); }
\\\'(\{)?a           { printf("&#xe1;"); }
\\\^(\{)?a           { printf("&#xe2;"); }
\\\~(\{)?a           { printf("&#xe3;"); }
\\\"(\{)?a           { printf("&#xe4;"); }
\\\r(\{)?a           { printf("&#xe5;"); }
\\ae                 { printf("&#xe6;"); }
\\\c(\{)?c           { printf("&#xe7;"); }
\\\`(\{)?e           { printf("&#xe8;"); }
\\\'(\{)?e           { printf("&#xe9;"); }
\\\^(\{)?e           { printf("&#xea;"); }
\\\"(\{)?e           { printf("&#xeb;"); }
\\\`(\{)?i           { printf("&#xec;"); }
\\\'(\{)?i           { printf("&#xed;"); }
\\\^(\{)?i           { printf("&#xee;"); }
\\\"(\{)?i           { printf("&#xef;"); }

\\\~(\{)?n           { printf("&#xf1;"); }
\\\`(\{)?o           { printf("&#xf2;"); }
\\\'(\{)?o           { printf("&#xf3;"); }
\\\^(\{)?o           { printf("&#xf4;"); }
\\\~(\{)?o           { printf("&#xf5;"); }
\\\"(\{)?o           { printf("&#xf6;"); }
\\oe                 { printf("oe"); }
\\o                  { printf("&#xf8;"); }
\\\`(\{)?u           { printf("&#xf9;"); }
\\\'(\{)?u           { printf("&#xfa;"); }
\\\^(\{)?u           { printf("&#xfb;"); }
\\\"(\{)?u           { printf("&#xfc;"); }
\\\'(\{)?y           { printf("&#xfd;"); }

&                    { printf("&amp;"); }
\\^^b\{a\}           { printf("&#xe4;"); }
\\^^b\{o\}           { printf("&#xf6;"); }
\\^^b\{u\}           { printf("&#xfc;"); }
\\'\{\\i\}           { printf("&#xed;"); }
\{\\`e\}             { printf("&#xe8;"); }
\\c\{c\}             { printf("&#xe7;"); }
n\\textsuperscript\{o\} { printf("&#x2116;"); }
\\kern.2em           { printf("span width=\"0.2em\"/>"); }
\\relax              { }
[^\\]\$\^\{\\mbox\{\\scriptsize\  { 
                       put_possibly(yytext[0]); 
                       printf("<sup>");
                       BEGIN(textsuper); }
ed\\raise1ex\\hbox\{\\underbar\{\\scriptsize[\n\t ]+\\'on\}\} {
                       printf("ed<sup><u>&#xf3;n</u></sup>"); }
\\raise1ex\\hbox\{\\underbar\{\\scriptsize[\n\t ]+a\}\} {
                       printf("&#xaa;"); }
\\raise1ex\\hbox\{\\underbar\{\\scriptsize[\n\t ]+o\}\} {
                       printf("&#xba;"); }
\\aa                 { printf("&#xe5;"); }
\{\\v\ s\}           { printf("&#x161;"); }
~                    { printf("&#160;"); }
\\#                  { printf("#"); }
---                  { printf("&#8212;"); }
--                   { printf("&#8211;"); }
\\,                  { printf("&#x2009;"); }
\\\/                 { }
\"=                  { printf("-"); }
\\-                  { }
[^\\]%\n             { put_possibly(yytext[0]); }
\\mbox               { }
\\                   { }
<INITIAL>[^\\]\$     { put_possibly(yytext[0]); 
                       printf("<m>{}"); BEGIN(inmath); }
<INITIAL>\\url\{     { printf("<url>"); BEGIN(inurl); }
<INITIAL>\\emph\{    { printf("<em>"); BEGIN(inemph); }
<INITIAL>[\{\\\}]    { }
<inmath>[^\\]\$      { putchar(yytext[0]); 
                       printf("</m>"); BEGIN(INITIAL); }
<inmath>\<           { printf("&lt;"); }
<inmath>\>           { printf("&gt;"); }
<inurl>\}            { printf("</url>"); BEGIN(INITIAL); }
<inemph>\}           { printf("</em>"); BEGIN(INITIAL); }
<textsuper>\}\}\$    { printf("</sup>"); 
                       BEGIN(INITIAL); }
%%

main(int argc, char* argv[])
{
  yylex();
  printf("\n");
}

